//+------------------------------------------------------------------+
//|                                               CME_TICK_CHART.mq4 |
//|                     Copyright  20122013, Financial Arsenal LTD |
//|                                     http://www.arsenal-forex.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  20122013, Financial Arsenal LTD"
#property link      "http://www.arsenal-forex.ru/"
//+------------------------------------------------------------------+
#import "user32.dll"
  int   RegisterWindowMessageA(string lpString);
  int   SetTimer(int hWnd,int nIDEvent,int uElapse,int& lpTimerFunc[]);
  bool  KillTimer(int hWnd,int uIDEvent);
#import "kernel32.dll"
  int   GetModuleHandleA(string lpModuleName);
  int   GetProcAddress(int hModule,string lpProcName);   
#import
//+------------------------------------------------------------------+
//| Super Global Variables                                           |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 White
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 Blue
//+------------------------------------------------------------------+
//| Extern Variables                                                 |
//+------------------------------------------------------------------+
extern   bool  Delayed_Futures                              = false  ;
extern   int   Calculate_Bars                               = 1000   ;
extern   bool  Clean_Chart                                  = false  ;
extern   int   Volume_Limit_for_Show                        = 15     ;
extern   bool  Show_Spot_Line                               = true   ;
extern   bool  Show_FutureBid_line                          = true   ;
extern   bool  Show_FutureAsk_line                          = true   ;
extern   bool  Show_FutureLast_line                         = true   ;
//+------------------------------------------------------------------+
//|   Includes			                                                |
//+------------------------------------------------------------------+
//#include <OBJECTS_CLASSES.mqh>
//#include <AlertsAndSounds.mqh>//GetInfo("");		
//+------------------------------------------------------------------+
//|   Defines & Global variavles                                     |
//+------------------------------------------------------------------+
#define empty  EMPTY_VALUE

//+------------------------------------------------------------------+
string Symbols[14]={"AUDUSD","CADUSD","CHFUSD","EURUSD","EURGBP","EURJPY","GBPUSD","NZDUSD","USDJPY","USDCAD","USDCHF","6EM3","6EU3","6EZ3"};
string fsy, lsy, sy;
bool first;
//--- buffers
double bid[];
double ask[];
double last[];
double short[];
double long[];
double spot[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init(){
	//---- indicators
	IndicatorShortName("CME_TICK_CHART");
	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(Show_FutureBid_line){SetIndexStyle(0,DRAW_SECTION);}else{SetIndexStyle(0,DRAW_NONE);}
   SetIndexBuffer(0,bid);
   SetIndexLabel(0,"Future Bid");
   if(Show_FutureAsk_line){SetIndexStyle(1,DRAW_SECTION);}else{SetIndexStyle(1,DRAW_NONE);}
   SetIndexBuffer(1,ask);
   SetIndexLabel(1,"Future Ask");
   if(Show_FutureLast_line){SetIndexStyle(2,DRAW_SECTION);}else{SetIndexStyle(2,DRAW_NONE);}
   SetIndexBuffer(2,last);
   SetIndexLabel(2,"Future Last");
   if(Show_Spot_Line){
      SetIndexStyle(3,DRAW_SECTION);
      SetIndexBuffer(3,spot);
      SetIndexLabel(3,"Spot Bid");
   }
   //----
   SetIndexBuffer(4,short);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,108);
   SetIndexEmptyValue(4,EMPTY_VALUE);
   SetIndexBuffer(5,long);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,108);
   SetIndexEmptyValue(5,EMPTY_VALUE);
	//----
	sy = Symbol();
	if(StringFind(sy,"f")<0){
	   if(Delayed_Futures){
	      fsy = "df"+Symbol();
	      lsy = "df"+Symbol()+"_L";
	   }else{
	      fsy = "f"+Symbol();
	      lsy = "f"+Symbol()+"_L";
	   }
	}else{
      if(StringFind(sy,"_L")<0){
         fsy = Symbol();
	      lsy = Symbol()+"_L";
      }else{
         fsy = StringSubstr(Symbol(),0,StringFind(Symbol(),"_L"));
	      lsy = Symbol();
      }	  
	}
	first  = true;
	sy = StringSubstr(fsy,StringFind(fsy,"f")+1);
	SetMyTimer(WindowHandle(Symbol(),Period()),100);
return;}
//+------------------------------------------------------------------+
void deinit(){
   if(!Clean_Chart){FileReadWrite(ask,bid,last,spot,short,long,false);}else{DeleteFile();}
   KillMyTimer();
   return;
}
//+------------------------------------------------------------------+
void start(){
	//----
	if(!IsSymbol()){Comment("Not yet futures for this symbol.");return;}	
   if(first){
      if(!Clean_Chart){FileReadWrite(ask,bid,last,spot,short,long,true);}
      first = false;
   }
	//----
	static int pretime=0,prevol=0,preshort=0,prelong=0;
	static double prerp = 0;	 
   int i, ii, x, y, counted = IndicatorCounted();
   if (counted > 0) counted--;
   int limit = Bars - counted;
   int vlong,vshort,cvol,vol = iVolume(lsy,Period(),0);
   int DG = MarketInfo(fsy,MODE_DIGITS);
   double sm = iOpen(fsy,Period(),0)-iOpen(sy,Period(),0);
   int per   = Period();
   string txt="";
   //----
   double lbid  = nd(MarketInfo(fsy,MODE_BID));
   double lask  = nd(MarketInfo(fsy,MODE_ASK));
   double llast = nd(MarketInfo(lsy,MODE_BID));
   double lspot = nd(MarketInfo(sy,MODE_BID)+sm);
      //----        
   if(NewBar()){
      for(i=0;i<=Calculate_Bars;i++){
         bid[i]   = bid[i+1];
         ask[i]   = ask[i+1];
         last[i]  = last[i+1];
         spot[i]  = spot[i+1];
         long[i]  = long[i+1];
         short[i] = short[i+1];
         long[i+1] = EMPTY_VALUE;
         short[i+1] = EMPTY_VALUE; 
      }  
   }
	//----
	if((lbid==nd(bid[0]))&&(lask==nd(ask[0]))&&(llast==nd(last[0]))){return;}
	//----
   for(i=Calculate_Bars;i>0;i--){
   	bid[i]   = bid[i-1];
   	ask[i]   = ask[i-1];
   	last[i]  = last[i-1];
   	spot[i]  = spot[i-1];
   	long[i]  = long[i-1];
   	short[i] = short[i-1]; 
   	long[i-1] = EMPTY_VALUE;
   	short[i-1] = EMPTY_VALUE;
   }
   //----
   bid[0]  = lbid;
   ask[0]  = lask;
   last[0] = llast;
   spot[0] = lspot;
   if(!Show_FutureBid_line&&
      !Show_FutureAsk_line&&
      !Show_FutureLast_line){spot[0] = nd(MarketInfo(sy,MODE_BID));}
   //----
   if(prevol == vol){return;}
   if(prevol > vol){
      prevol = 0;
   }
   cvol = vol - prevol;
   if(last[0] >= ask[0]){
      if(cvol>Volume_Limit_for_Show){
         GetInfo("Future Long Volume = "+cvol);
         if(!Show_FutureBid_line&&
            !Show_FutureAsk_line&&
            !Show_FutureLast_line){long[0]=spot[0];}else{long[0]=ask[0];}
      }
   }
   if(last[0] <= bid[0]){
      if(cvol>Volume_Limit_for_Show){
         GetInfo("Future Short Volume = "+cvol);
         if(!Show_FutureBid_line&&
            !Show_FutureAsk_line&&
            !Show_FutureLast_line){short[0]=spot[0];}else{short[0]=bid[0];}
      }
   }
   prevol = vol;
	//----
return;}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteFile(){int hd;string fn = sy+"_CME_TICK_CHART.bin";
   hd = FileOpen(fn,FILE_BIN|FILE_READ);
   if(hd < 1){return;}
   FileClose(hd);
   FileDelete(fn);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void FileReadWrite(double &a[],double &b[], double &l[],double &s[],double &ar[],double &ab[],bool r_w){int i,hd;string fn = sy+"_CME_TICK_CHART.bin";
   if(r_w){
      hd = FileOpen(fn,FILE_BIN|FILE_READ);
      if(hd<1){return;}
      for(i=0;i<Calculate_Bars;i++){
         double aa = FileReadDouble(hd,FLOAT_VALUE);
         if(aa>10000){a[i] = EMPTY_VALUE;}else{a[i] = aa;}
         double bb = FileReadDouble(hd,FLOAT_VALUE);
         if(bb>10000){b[i] = EMPTY_VALUE;}else{b[i] = bb;}
         double ll = FileReadDouble(hd,FLOAT_VALUE);
         if(ll>10000){l[i] = EMPTY_VALUE;}else{l[i] = ll;}
         double ss = FileReadDouble(hd,FLOAT_VALUE);
         if(ss>10000){s[i] = EMPTY_VALUE;}else{s[i] = ss;}
         double aar = FileReadDouble(hd,FLOAT_VALUE);
         if(aar>10000){ar[i] = EMPTY_VALUE;}else{ar[i] = aar;}
         double aab = FileReadDouble(hd,FLOAT_VALUE);
         if(aab>10000){ab[i] = EMPTY_VALUE;}else{ab[i] = aab;}
      }
      FileClose(hd);
   }else{
      hd = FileOpen(fn,FILE_BIN|FILE_WRITE);
      if(hd<1){return;}
      for(i=0;i<Calculate_Bars;i++){
         FileWriteDouble(hd,a[i],FLOAT_VALUE);
         FileWriteDouble(hd,b[i],FLOAT_VALUE);
         FileWriteDouble(hd,l[i],FLOAT_VALUE);
         FileWriteDouble(hd,s[i],FLOAT_VALUE);
         FileWriteDouble(hd,ar[i],FLOAT_VALUE);
         FileWriteDouble(hd,ab[i],FLOAT_VALUE);
      }
      FileClose(hd);
   }
   return;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool NewBar(){static int pretm=0;
   if(pretm==0){pretm=Time[0];}
   if(pretm==Time[0]){return(false);}
   pretm = Time[0];
   return(true);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double nd(double in){return(NormalizeDouble(in,MarketInfo(fsy,MODE_DIGITS)));}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int SetMyTimer(int TimerId, int Interval){    
  int hWnd= WindowHandle(Symbol(),Period());
  int MT4InternMsg= RegisterWindowMessageA("MetaTrader4_Internal_Message");
  int PostMsgAddr= GetProcAddress(GetModuleHandleA("user32.dll"),"PostMessageA");
  if (PostMsgAddr==0 || hWnd==0) return(0);
  // push ebp; move ebp,esp; push 01; push 02; push MT4InternMsg; push hWnd; mov eax,PostMsgAddr; call eax; pop ebp; ret 0010;    
  int value[]={ 0x55, 0x8B,0xEC, 0x6A,01, 0x6A,02, 0x68,0000, 0x68,0000, 0xB8,0000, 0xFF,0xD0, 0x5D, 0xC2,0x10 };
  int len[]=  { 1,    1,   1,    1,   1,  1,   1,  1,   4,    1,   4,    1,   4,    1,   1,    1,    1,   2 };
  value[8]=MT4InternMsg;  value[10]=hWnd;  value[12]=PostMsgAddr;
  static int TimerCode[7];  ArrayInitialize(TimerCode,0);
  int byte=0;  
  for (int i=0;  i<ArraySize(value);  i++)
    for (int j=0;  j<len[i];  j++, byte++)
      TimerCode[byte/4] |= value[i]>>(8*j)&0xFF<<(byte%4*8);

  return ( SetTimer(hWnd, TimerId, Interval, TimerCode) );
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool KillMyTimer(){return( KillTimer(WindowHandle(Symbol(),Period()), WindowHandle(Symbol(),Period())) );}
//+------------------------------------------------------------------+
//|          Description:                                            |
//+------------------------------------------------------------------+
bool IsSymbol(){int i;
   for(i=0;i<ArraySize(Symbols);i++){if(StringFind(Symbol(),Symbols[i])>=0){return(true);}}
   return(false);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, XrustSolution."
#property link      "mail: xrustx@gmail.com"
//#include <Errors.mqh>
//+------------------------------------------------------------------+
//| extern variables                                                 |
//+------------------------------------------------------------------+
extern 	string  	AlertsAndSoundSetting="##### Alerts&SoundSetting #####";
extern 	bool    	UseAlert             							= false	;						
extern 	bool    	SendEmail            							= false	;
extern   bool     SendUserNotification					         = false  ;
extern 	bool    	UseSound             							= false  ; 						
extern 	string  	NameFileSound        							= "news.wav";	
extern 	string  	EmailSubject         							= ""		;					
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void GetInfo(string in=""){
   GetAlert(in);
   GetEmail(in);
   GetNotification(in);
   GetSound();
   return;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void GetAlert(string in = ""){
   if(!UseAlert){return;}
   Alert(Symbol()+"  "+tf2tx(Period())+"  "+in);
   return;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string tf2tx(int tf){
   switch(tf){
      case PERIOD_M1 : return("M1");
      case PERIOD_M5 : return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1 : return("H1");
      case PERIOD_H4 : return("H4");
      case PERIOD_D1 : return("D1");
      case PERIOD_W1 : return("W1");
      case PERIOD_MN1: return("MN1");
      default        : return(" "+Period());
   }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void GetSound(){
   if(!UseSound){return;}
   PlaySound(NameFileSound);
   return;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void GetEmail(string in){
   if(!SendEmail){return;}
   SendMail(EmailSubject,Symbol()+"  "+tf2tx(Period())+"\n"+in);
   return;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void GetNotification(string in){
   if(!SendUserNotification){return;}
   SendNotification(Symbol()+"  "+tf2tx(Period())+"\n"+in);
}
//+------------------------------------------------------------------+