//+------------------------------------------------------------------+
//|                                                        CME_N.mq4 |
//|                     Copyright  20122013, Financial Arsenal LTD |
//|                                     http://www.arsenal-forex.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  20122013, Financial Arsenal LTD"
#property link      "http://www.arsenal-forex.ru/"
//+------------------------------------------------------------------+
//| Super Global Variables                                           |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Green
#property indicator_level1 0
//+------------------------------------------------------------------+
//| Extern Variables                                                 |
//+------------------------------------------------------------------+
extern   bool  Delayed_Futures                              = false  ;
extern   int   Calculate_Bars                               = 1000   ;
extern   bool  Sinshonise_with_TickChart                    = true   ;
extern   bool  Clear_Chart                                  = false  ;
//+------------------------------------------------------------------+
//|   Includes			                                                |
//+------------------------------------------------------------------+
//#include <OBJECTS_CLASSES.mqh>
//#include <AlertsAndSounds.mqh>//GetInfo("");		
//+------------------------------------------------------------------+
//|   Defines & Global variavles                                     |
//+------------------------------------------------------------------+
#define empty  EMPTY_VALUE
//+------------------------------------------------------------------+
string Symbols[14]={"AUDUSD","CADUSD","CHFUSD","EURUSD","EURGBP","EURJPY","GBPUSD","NZDUSD","USDJPY","USDCAD","USDCHF","6EM3","6EU3","6EZ3"};
string fsy, lsy, sy;
bool   set_tm,first;
//--- buffers
double svol[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init(){
	//---- indicators
	IndicatorShortName("CME_TICK_SUMM");
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexBuffer(0,svol);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0,"Summary Volume Delta");
	//----
		sy = Symbol();
	if(StringFind(sy,"f")<0){
	   if(Delayed_Futures){
	      fsy = "df"+Symbol();
	      lsy = "df"+Symbol()+"_L";
	   }else{
	      fsy = "f"+Symbol();
	      lsy = "f"+Symbol()+"_L";
	   }
	}else{
      if(StringFind(sy,"_L")<0){
         fsy = Symbol();
	      lsy = Symbol()+"_L";
      }else{
         fsy = StringSubstr(Symbol(),0,StringFind(Symbol(),"_L"));
	      lsy = Symbol();
      }	  
	}
	sy = StringSubstr(fsy,StringFind(fsy,"f")+1);
	IndicatorDigits(0);
	set_tm = false;
	first  = true;
	if(WindowFind("CME_TICK_CHART")<0&&
	   WindowFind("CME_TICK_VOLUME")<0){
	     set_tm = true; 
	     SetMyTimer(WindowHandle(Symbol(),Period()),100);
	}
return;}
//+------------------------------------------------------------------+
void deinit(){
   if(!Clear_Chart){FileReadWrite(svol,false);}else{DeleteFile();}
   if(set_tm){KillMyTimer();}
   return;
}
//+------------------------------------------------------------------+
void start(){
	//----
	if(!IsSymbol()){Comment("Not yet futures for this symbol.");return;}	
   if(first){
      if(!Clear_Chart){FileReadWrite(svol,true);}
      first = false;
   }
	//----
	static int pretime=0,prevol=0,preshort=0,prelong=0;
	static double prerp = 0,preb,prea,prel;	 
   int i, ii, x, y, counted = IndicatorCounted();
   if (counted > 0) counted--;
   int limit = Bars - counted;
   int vlong,vshort,cvol,vol = iVolume(lsy,Period(),0);
   int DG = MarketInfo(fsy,MODE_DIGITS);
   double sm = iOpen(fsy,Period(),0)-iOpen(sy,Period(),0);
   int per   = Period();
   string txt="";
   //----    
   double lbid = nd(MarketInfo(fsy,MODE_BID));
   double lask = nd(MarketInfo(fsy,MODE_ASK));
   double llast = nd(MarketInfo(lsy,MODE_BID));
   //----        
   if(NewBar()){
      for(i=0;i<=Calculate_Bars;i++){
         svol[i]=svol[i+1];
      }  
   }
	//----
   if(prevol == 0){prevol = vol;}
   if(Sinshonise_with_TickChart){
      if((lbid==nd(preb))&&(lask==nd(prea))&&(llast==nd(prel))){return;}
   }else{
      if(vol<1){return;}
      if(prevol == vol){return;}
   }
   //
	//----
   if(prevol == 0){prevol = vol;}

   if(prevol > vol){
      prevol   = 0;
   }
   cvol = vol - prevol;
   //----
   for(i=Calculate_Bars;i>0;i--){
   	svol[i]=svol[i-1];
   }
   if(llast >= lask){
      svol[0] += cvol;
   }
   if(llast <= lbid){
      svol[0] -= cvol;
   }
   prevol = vol;
   preb = lbid;
	prea = lask;
	prel = llast;
	//----
return;}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteFile(){int hd;string fn = sy+"_CME_TICK_VOLUME.bin";
   hd = FileOpen(fn,FILE_BIN|FILE_READ);
   if(hd < 1){return;}
   FileClose(hd);
   FileDelete(fn);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void FileReadWrite(double &s[],bool r_w){int i,hd;string fn = sy+"_CME_TICK_SUMM.bin";
   if(r_w){
      hd = FileOpen(fn,FILE_BIN|FILE_READ);
      if(hd<1){return;}
      for(i=0;i<Calculate_Bars;i++){
         s[i] = MathRound(FileReadDouble(hd,FLOAT_VALUE));
      }
      FileClose(hd);
   }else{
      hd = FileOpen(fn,FILE_BIN|FILE_WRITE);
      if(hd<1){return;}
      for(i=0;i<Calculate_Bars;i++){
         FileWriteDouble(hd,s[i],FLOAT_VALUE);
      }
      FileClose(hd);
   }
   return;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#import "user32.dll"
  int   RegisterWindowMessageA(string lpString);
  int   SetTimer(int hWnd,int nIDEvent,int uElapse,int& lpTimerFunc[]);
  bool  KillTimer(int hWnd,int uIDEvent);
#import "kernel32.dll"
  int   GetModuleHandleA(string lpModuleName);
  int   GetProcAddress(int hModule,string lpProcName);   
#import
//+------------------------------------------------------------------+
int SetMyTimer(int TimerId, int Interval){    
  int hWnd= WindowHandle(Symbol(),Period());
  int MT4InternMsg= RegisterWindowMessageA("MetaTrader4_Internal_Message");
  int PostMsgAddr= GetProcAddress(GetModuleHandleA("user32.dll"),"PostMessageA");
  if (PostMsgAddr==0 || hWnd==0) return(0);
  // push ebp; move ebp,esp; push 01; push 02; push MT4InternMsg; push hWnd; mov eax,PostMsgAddr; call eax; pop ebp; ret 0010;    
  int value[]={ 0x55, 0x8B,0xEC, 0x6A,01, 0x6A,02, 0x68,0000, 0x68,0000, 0xB8,0000, 0xFF,0xD0, 0x5D, 0xC2,0x10 };
  int len[]=  { 1,    1,   1,    1,   1,  1,   1,  1,   4,    1,   4,    1,   4,    1,   1,    1,    1,   2 };
  value[8]=MT4InternMsg;  value[10]=hWnd;  value[12]=PostMsgAddr;
  static int TimerCode[7];  ArrayInitialize(TimerCode,0);
  int byte=0;  
  for (int i=0;  i<ArraySize(value);  i++)
    for (int j=0;  j<len[i];  j++, byte++)
      TimerCode[byte/4] |= value[i]>>(8*j)&0xFF<<(byte%4*8);

  return ( SetTimer(hWnd, TimerId, Interval, TimerCode) );
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool KillMyTimer(){return( KillTimer(WindowHandle(Symbol(),Period()), WindowHandle(Symbol(),Period())) );}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool NewBar(){static int pretm=0;
   if(pretm==0){pretm=Time[0];}
   if(pretm==Time[0]){return(false);}
   pretm = Time[0];
   return(true);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double nd(double in){return(NormalizeDouble(in,MarketInfo(fsy,MODE_DIGITS)));}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsSymbol(){int i;
   for(i=0;i<ArraySize(Symbols);i++){
      if(StringFind(Symbol(),Symbols[i])>=0){
         return(true);
      }
   }
   return(false);
}
//+------------------------------------------------------------------+